/*
TASK: monument
LANG: C++
*/
#define M_PI 3.141459
#include<stdio.h>
#include<math.h>
#define mx 512
#define eps 1e-9
#define in stdin;//fopen("c:\\djgpp\\guest\\in.txt","r")
FILE*fn;
struct lineeq{double a,b,c;};
struct point
  {double x,y;
  point(void){x=y=0.0;}
  point(double a,double b){x=a;y=b;}
  };
struct segment
  {point a,b;
  segment(void){a=b=point(0.0,0.0);}
  segment(point aa,point bb){a=aa;b=bb;}
  };

int eq(double a,double b)
  {double c1=a-b;
  if(c1<0.0)c1=-c1;
  if(c1<eps)return 1;
  return 0;}

lineeq findeq(segment a)
  {lineeq e1;
  e1.b=a.b.x-a.a.x;
  e1.a=a.a.y-a.b.y;
  e1.c=a.a.x*a.b.y-a.a.y*a.b.x;
  return e1;}

point operator-(point a,point b){return point(a.x-b.x,a.y-b.y);}
point operator+(point a,point b){return point(a.x+b.x,a.y+b.y);}
point operator*(point a,double b){return point(a.x*b,a.y*b);}
double operator%(point a,point b){return hypot(a.x-b.x,a.y-b.y);}
double operator^(point a,point b){return a.x*b.y-a.y*b.x;}
int operator==(point a,point b){return eq(a.x,b.x)&&eq(a.y,b.y);}

double det2(point a,point b,point c)
  {return (b-a)^(c-a);}

int operator==(segment a,segment b)
  {lineeq s1,s2;
  double c1,c2,c3,c4;
  /*s1=findeq(a);
  s2=findeq(b);
  if(eq(s2.a,0.0)||eq(s2.b,0.0)||eq(s2.c,0.0))
    {if(eq(s2.a*s1.b-s2.b*s1.a,0.0)&&eq(s1.c*s2.b-s2.c*s1.b,0.0))return 1;
    return 0;}
  if(eq(s1.a/s2.a,s1.b/s2.b)&&eq(s1.c/s2.c,s1.b/s2.b))return 1;*/
  c1=det2(a.a,a.b,b.a);
  c2=det2(a.a,a.b,b.b);
  if(eq(c1+c2,0.0))return 1;
  return 0;}

point rotate(point a,point b,double ang,double neww)
  {point e1,e2,e3,e4;
  e1=b-a;
  e1=(e1*(1.0/(a%b)))*neww;
  e2.x=cos(ang)*e1.x-sin(ang)*e1.y;
  e2.y=sin(ang)*e1.x+cos(ang)*e1.y;
  if(ang>0.0)e2.x=-e1.y;else e2.x=e1.y;
  if(ang>0.0)e2.y=e1.x;else e2.y=-e1.x;
  e2=e2+a;
  return e2;}

int ifcross(segment e1,segment e2)
  {double c1,c2,c3,c4;
  if(e1==e2)return 0;
  c1=det2(e1.a,e1.b,e2.a);
  c2=det2(e1.a,e1.b,e2.b);
  if(c1*c2<=0.0)return 1;
  return 0;}
point find(segment e1,segment e2)
  {lineeq s1,s2;
  point ans;
  double a1,b1,c1,a2,c2,b2;
  s1=findeq(e1);
  s2=findeq(e2);
  a1=s1.a;a2=s2.a;
  b1=s1.b;b2=s2.b;
  c1=s1.c;c2=s2.c;
  ans.x=(c1*b2-c2*b1)/(a2*b1-a1*b2);
  ans.y=(a2*c1-a1*c2)/(a1*b2-a2*b1);
  return ans;}

segment ss[mx];
int cc;
segment s1[mx];
int sc;

int insert(segment a)
  {int q1,rc=0,q2;
  point r[10];
  point e1,e2;
  double c1,c2;
  sc=0;
  for(q1=0;q1<cc;q1++)
    {if(!ifcross(a,ss[q1]))
      {s1[sc++]=ss[q1];
      continue;}
    e1=find(ss[q1],a);

    for(q2=0;q2<rc;q2++)if(e1==r[q2])break;
    r[q2]=e1;
    if(q2==rc)rc++;

    s1[sc++]=segment(ss[q1].a,e1);
    s1[sc++]=segment(e1,ss[q1].b);
    }
  cc=0;
  for(q1=0;q1<sc;q1++)
    {c1=det2(a.a,a.b,s1[q1].a);
    c2=det2(a.a,a.b,s1[q1].b);
    if(c1>0.0||c2>0.0)
      {int cc1,cc2;
      cc1=eq(c1,0.0);
      cc2=eq(c2,0.0);
      if(c1>0.0&&(!cc1))continue;
      if(c2>0.0&&(!cc2))continue;}

    if(eq(s1[q1].a%s1[q1].b,0.0))continue;
    ss[cc++]=s1[q1];}

  if(rc==2)
    if(!eq(r[0]%r[1],0.0))
      ss[cc++]=segment(r[0],r[1]);

  if(cc!=0)return 1;
  return 0;}



int c,q1,q2,c1;
point si[mx];
segment s[mx];

int trie(double d)
  {int q1,q2;
  segment e1;
  point p1,p2;
  for(q1=0;q1<c;q1++)ss[q1]=s[q1];
  cc=c;
  for(q1=0;q1<c;q1++)
    {p1=s[q1].a;
    p2=s[q1].b;
    e1.a=rotate(p1,p2,-M_PI/2.0,d);
    e1.b=rotate(p2,p1,M_PI/2.0,d);
    if(insert(e1)==0)return 0;}

  return 1;}

double l,r,m;

int main()
  {fn=in;
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)
    fscanf(fn,"%lf %lf",&si[q1].x,&si[q1].y);
  fclose(fn);
  si[c]=si[0];
  for(q1=0;q1<c;q1++)s[q1]=segment(si[q1],si[q1+1]);
  l=eps;
  r=3000.0;
  for(q1=0;q1<40;q1++)
    {m=(l+r)/2.0;
    c1=trie(m);
    if(c1)l=m;
    else r=m;}
  printf("%.6lf\n",l);
  return 0;}
