/*
TASK:monument
LANG:C++
*/
#include <stdio.h>
#include <math.h>
#include <limits.h>

#define ORAREA(x1,y1,x2,y2,x3,y3) ((x1-x3)*(y2-y3)-(x2-x3)*(y1-y3))
#define ORAREA2(p1,p2,p3) ORAREA(p1.x,p1.y,p2.x,p2.y,p3.x,p3.y)

typedef double ftype;

struct Point
{
    ftype x,y;
};

struct Line
{
    ftype a,b,c;
};

#define N 512

int n;
Point ps[N];

void ptol(Point p1, Point p2, Line &l)
{
    if(p1.x==p2.x)
    {
	l.a=1;
	l.b=0;
    }
    else
    {
	l.b=1;
	l.a=(p2.y-p1.y)/(p1.x-p2.x);
    }
    l.c= -(l.a*p1.x + l.b*p1.y);
}

int ltop(Line l1, Line l2, Point &p)
{
    if(l1.a*l2.b==l2.a*l1.b) return 1;
    p.x=(l2.c*l1.b-l1.c*l2.b)/(l1.a*l2.b-l2.a*l1.b);
    p.y=(l1.c*l2.a-l2.c*l1.a)/(l1.a*l2.b-l2.a*l1.b);
    return 0;
}

void readf()
{
    int i;
    scanf("%d",&n);
    for(i=0; i<n ;i++) scanf("%lf %lf",&ps[i].x,&ps[i].y);
}


#define dpoint(p) printf("%lf %lf\n",p.x,p.y);
#define DIST(p1,p2) hypot(p1.x-p2.x,p1.y-p2.y)
ftype a,b,c,p,r,mr;
Line l1,l2,l3;
Point p1,p2,p3;
void triang(int x, int y, int z)
{
    //printf("%d %d %d\n",x,y,z);
    // check valid tri
    ptol(ps[x],ps[(x+1)%n],l1);
    ptol(ps[y],ps[(y+1)%n],l2);
    ptol(ps[z],ps[(z+1)%n],l3);
    //printf("%lf %lf %lf\n",l1.a,l1.b,l1.c);
    //printf("%lf %lf %lf\n",l2.a,l2.b,l2.c);
    //printf("%lf %lf %lf\n",l3.a,l3.b,l3.c);
    if(ltop(l1,l2,p1))
    {
	r=(l1.a*ps[y].x+l1.b*ps[y].y+l1.c)/(2*sqrt(l1.a*l1.a+l1.b*l1.b));
	if(r<0) r= -r;
	if(r<mr) mr=r;
	return;
    }
    if(ltop(l2,l3,p2))
    {
	r=(l2.a*ps[z].x+l2.b*ps[z].y+l2.c)/(2*sqrt(l2.a*l2.a+l2.b*l2.b));
	if(r<0) r= -r;
	if(r<mr) mr=r;
	return;
    }
    if(ltop(l3,l1,p3))
    {
	r=(l3.a*ps[x].x+l3.b*ps[x].y+l3.c)/(2*sqrt(l3.a*l3.a+l3.b*l3.b));
	if(r<0) r= -r;
	if(r<mr) mr=r;
	return;
    }
    if(ORAREA2(p1,ps[z],ps[(z+1)%n])>0)return;
    if(ORAREA2(p2,ps[x],ps[(x+1)%n])>0)return;
    if(ORAREA2(p3,ps[y],ps[(y+1)%n])>0)return;
    // comp
    //dpoint(p1);dpoint(p2);dpoint(p3);
    a=DIST(p1,p2);
    b=DIST(p2,p3);
    c=DIST(p3,p1);
    p=(a+b+c)/2;
    r=sqrt(p*(p-a)*(p-b)*(p-c))/p;
    if(r<mr) mr=r;
}

void solve()
{
    int i,j,k;
    for(i=0; i<n; i++)
	for(j=i+1; j<n; j++)
	    for(k=j+1; k<n; k++)
		triang(i,j,k);
}

int main()
{
    mr = 1<<20;
    readf();
    solve();
    printf("%lf\n",mr);
    return 0;
}

